Index: /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs	(revision 3578)
@@ -44,4 +44,5 @@
 using HeuristicLab.Hive.JobBase;
 using HeuristicLab.Hive.Client.Core.JobStorage;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Client.Core {
@@ -51,5 +52,14 @@
   public class Core : MarshalByRefObject {
     public static bool abortRequested { get; set; }
-    private bool currentlyFetching = false;
+
+    private bool _currentlyFetching;
+    private bool CurrentlyFetching { 
+      get {
+        return _currentlyFetching;
+      } set {        
+        _currentlyFetching = value;
+        Logger.Debug("Set CurrentlyFetching to " + _currentlyFetching);
+      } 
+    }
 
     private Dictionary<Guid, Executor> engines = new Dictionary<Guid, Executor>();
@@ -65,5 +75,5 @@
     public void Start() {
       abortRequested = false;
-      Logging.Instance.Info(this.ToString(), "Hive Client started");
+      Logger.Info("Hive Client started");
       ClientConsoleServer server = new ClientConsoleServer();
       server.StartClientConsoleServer(new Uri("net.tcp://127.0.0.1:8000/ClientConsole/"));
@@ -104,5 +114,5 @@
         DetermineAction(container);
       }
-      System.Console.WriteLine("ended");
+      Logger.Info("Program shutdown");
     }
 
@@ -112,5 +122,5 @@
     /// <param name="container">The Container, containing the message</param>
     private void DetermineAction(MessageContainer container) {
-      Logging.Instance.Info(this.ToString(), "Message: " + container.Message.ToString() + " for job: " + container.JobId);        
+      Logger.Info("Message: " + container.Message.ToString() + " for job: " + container.JobId);        
       switch (container.Message) {
         //Server requests to abort a job
@@ -119,5 +129,5 @@
             engines[container.JobId].Abort();
           else
-            Logging.Instance.Error(this.ToString(), "AbortJob: Engine doesn't exist");
+            Logger.Error("AbortJob: Engine doesn't exist");
           break;
         //Job has been successfully aborted
@@ -136,5 +146,5 @@
               GC.Collect();
             } else
-              Logging.Instance.Error(this.ToString(), "JobAbort: Engine doesn't exist");
+              Logger.Error("JobAbort: Engine doesn't exist");
           }
           break;
@@ -146,5 +156,5 @@
             engines[container.JobId].RequestSnapshot();
           else
-            Logging.Instance.Error(this.ToString(), "RequestSnapshot: Engine doesn't exist");
+            Logger.Error("RequestSnapshot: Engine doesn't exist");
           break;
 
@@ -158,9 +168,9 @@
         //Pull a Job from the Server
         case MessageContainer.MessageType.FetchJob:          
-          if (!currentlyFetching) {
+          if (!CurrentlyFetching) {
             wcfService.SendJobAsync(ConfigManager.Instance.GetClientInfo().Id);
-            currentlyFetching = true;
+            CurrentlyFetching = true;
           } else
-            Logging.Instance.Info(this.ToString(), "Currently fetching, won't fetch this time!");
+            Logger.Info("Currently fetching, won't fetch this time!");
           break;          
         
@@ -174,10 +184,10 @@
         //When the timeslice is up
         case MessageContainer.MessageType.UptimeLimitDisconnect:
-          Logging.Instance.Info(this.ToString(), "Uptime Limit reached, storing jobs and sending them back");
+          Logger.Info("Uptime Limit reached, storing jobs and sending them back");
 
           //check if there are running jobs
           if (engines.Count > 0) {
             //make sure there is no more fetching of jobs while the snapshots get processed
-            currentlyFetching = true;
+            CurrentlyFetching = true;
             //request a snapshot of each running job
             foreach (KeyValuePair<Guid, Executor> kvp in engines) {
@@ -193,26 +203,23 @@
           //Fetch or Force Fetch Calendar!
         case MessageContainer.MessageType.FetchOrForceFetchCalendar:
-          ResponseCalendar rescal = wcfService.GetCalendarSync(ConfigManager.Instance.GetClientInfo().Id);
-          if(rescal.Success) {
-            if(!UptimeManager.Instance.SetAppointments(false, rescal)) {
-              wcfService.SetCalendarStatus(ConfigManager.Instance.GetClientInfo().Id, CalendarState.NotAllowedToFetch);              
-            } else {
-              wcfService.SetCalendarStatus(ConfigManager.Instance.GetClientInfo().Id, CalendarState.Fetched);              
-            }
-          } else {
-            wcfService.SetCalendarStatus(ConfigManager.Instance.GetClientInfo().Id, CalendarState.NotAllowedToFetch);
-          }
+          Logger.Info("Fetch Calendar from Server");
+          FetchCalendarFromServer();  
         break;
 
         //Hard shutdown of the client
         case MessageContainer.MessageType.Shutdown:
+          Logger.Info("Shutdown Signal received");
           lock (engines) {
+            Logger.Debug("engines locked");
             foreach (KeyValuePair<Guid, AppDomain> kvp in appDomains) {
+              Logger.Debug("Shutting down Appdomain for " + kvp.Key);
               appDomains[kvp.Key].UnhandledException -= new UnhandledExceptionEventHandler(appDomain_UnhandledException);
               AppDomain.Unload(kvp.Value);
             }
           }
+          Logger.Debug("Stopping heartbeat");
           abortRequested = true;
           beat.StopHeartBeat();
+          Logger.Debug("Logging out");
           WcfService.Instance.Logout(ConfigManager.Instance.GetClientInfo().Id);
           break;
@@ -230,8 +237,8 @@
     private void GetFinishedJob(object jobId) {
       Guid jId = (Guid)jobId;
-      Logging.Instance.Info(this.ToString(), "Getting the finished job with id: " + jId);
+      Logger.Info("Getting the finished job with id: " + jId);
       try {
         if (!engines.ContainsKey(jId)) {
-          Logging.Instance.Error(this.ToString(), "GetFinishedJob: Engine doesn't exist");
+          Logger.Info("Engine doesn't exist");
           return;
         }
@@ -240,5 +247,5 @@
 
         if (WcfService.Instance.ConnState == NetworkEnum.WcfConnState.Loggedin) {
-          Logging.Instance.Info(this.ToString(), "Sending the finished job with id: " + jId);
+          Logger.Info("Sending the finished job with id: " + jId);
           wcfService.StoreFinishedJobResultAsync(ConfigManager.Instance.GetClientInfo().Id,
             jId,
@@ -248,25 +255,27 @@
             true);
         } else {
-          Logging.Instance.Info(this.ToString(), "Storing the finished job with id: " + jId + " to hdd");
+          Logger.Info("Storing the finished job with id: " + jId + " to hdd");
           JobStorageManager.PersistObjectToDisc(wcfService.ServerIP, wcfService.ServerPort, jId, sJob);
           lock (engines) {
             appDomains[jId].UnhandledException -= new UnhandledExceptionEventHandler(appDomain_UnhandledException);
             AppDomain.Unload(appDomains[jId]);
-            appDomains.Remove(jId);
-            engines.Remove(jId);
+            Logger.Debug("Unloaded appdomain");
+            appDomains.Remove(jId);            
+            engines.Remove(jId);            
             jobs.Remove(jId);
+            Logger.Debug("Removed job from appDomains, Engines and Jobs");
           }
         }
       }
       catch (InvalidStateException ise) {
-        Logging.Instance.Error(this.ToString(), "Exception: ", ise);
+        Logger.Error("Invalid State while Snapshoting:", ise);
       }
     }
 
     private void GetSnapshot(object jobId) {
-      Logging.Instance.Info(this.ToString(), "Fetching a snapshot for job " + jobId);
+      Logger.Info("Fetching a snapshot for job " + jobId);
       Guid jId = (Guid)jobId;
       byte[] obj = engines[jId].GetSnapshot();
-      Logging.Instance.Info(this.ToString(), "BEGIN: Sending snapshot sync");
+      Logger.Debug("BEGIN: Sending snapshot sync");
       wcfService.ProcessSnapshotSync(ConfigManager.Instance.GetClientInfo().Id,
         jId,
@@ -274,15 +283,23 @@
         engines[jId].Progress,
         null);
-      Logging.Instance.Info(this.ToString(), "END: Sended snapshot sync");
+      Logger.Debug("END: Sended snapshot sync");
       //Uptime Limit reached, now is a good time to destroy this jobs.
+      Logger.Debug("Checking if uptime limit is reached");
       if (!UptimeManager.Instance.IsOnline()) {
+        Logger.Debug("Uptime limit reached");
+        Logger.Debug("Killing Appdomain");
         KillAppDomain(jId);
-        //Still anything running?
-        if (engines.Count == 0)
+        //Still anything running?  
+        if (engines.Count == 0) {
+          Logger.Info("All jobs snapshotted and sent back, disconnecting");          
           WcfService.Instance.Disconnect();
+        } else {
+          Logger.Debug("There are still active Jobs in the Field, not disconnecting");
+        }
 
       } else {
-        Logging.Instance.Info(this.ToString(), "Restarting the job" + jobId);
+        Logger.Debug("Restarting the job" + jobId);
         engines[jId].StartOnlyJob();
+        Logger.Info("Restarted the job" + jobId);
       }
     }
@@ -299,8 +316,8 @@
     void wcfService_LoginCompleted(object sender, LoginCompletedEventArgs e) {
       if (e.Result.Success) {
-        currentlyFetching = false;
-        Logging.Instance.Info(this.ToString(), "Login completed to Hive Server @ " + DateTime.Now);
+        CurrentlyFetching = false;
+        Logger.Info("Login completed to Hive Server @ " + DateTime.Now);
       } else
-        Logging.Instance.Error(this.ToString(), e.Result.StatusMessage);
+        Logger.Error("Error during login: " + e.Result.StatusMessage);
     }
 
@@ -312,11 +329,11 @@
     void wcfService_SendJobCompleted(object sender, SendJobCompletedEventArgs e) {
       if (e.Result.StatusMessage != ApplicationConstants.RESPONSE_COMMUNICATOR_NO_JOBS_LEFT) {
-        Logging.Instance.Info(this.ToString(), "Received new job with id " + e.Result.Job.Id);      
+        Logger.Info("Received new job with id " + e.Result.Job.Id);      
         bool sandboxed = false;
         List<byte[]> files = new List<byte[]>();
-        Logging.Instance.Info(this.ToString(), "Fetching plugins for job " + e.Result.Job.Id);
+        Logger.Debug("Fetching plugins for job " + e.Result.Job.Id);
         foreach (CachedHivePluginInfoDto plugininfo in PluginCache.Instance.GetPlugins(e.Result.Job.PluginsNeeded))
           files.AddRange(plugininfo.PluginFiles);
-        Logging.Instance.Info(this.ToString(), "Plugins fetched for job " + e.Result.Job.Id);
+        Logger.Debug("Plugins fetched for job " + e.Result.Job.Id);
         AppDomain appDomain = HeuristicLab.PluginInfrastructure.Sandboxing.SandboxManager.CreateAndInitSandbox(e.Result.Job.Id.ToString(), files);
         appDomain.UnhandledException += new UnhandledExceptionEventHandler(appDomain_UnhandledException);
@@ -325,10 +342,10 @@
             jobs.Add(e.Result.Job.Id, e.Result.Job);
             appDomains.Add(e.Result.Job.Id, appDomain);
-            Logging.Instance.Info(this.ToString(), "Creating AppDomain");
+            Logger.Debug("Creating AppDomain");
             Executor engine = (Executor)appDomain.CreateInstanceAndUnwrap(typeof(Executor).Assembly.GetName().Name, typeof(Executor).FullName);
-            Logging.Instance.Info(this.ToString(), "Created AppDomain");
+            Logger.Debug("Created AppDomain");
             engine.JobId = e.Result.Job.Id;
             engine.Queue = MessageQueue.GetInstance();
-            Logging.Instance.Info(this.ToString(), "Starting Engine for job " + e.Result.Job.Id);
+            Logger.Debug("Starting Engine for job " + e.Result.Job.Id);
             engine.Start(e.Data);
             engines.Add(e.Result.Job.Id, engine);
@@ -336,10 +353,10 @@
             ClientStatusInfo.JobsFetched++;
 
-            Debug.WriteLine("Increment FetchedJobs to:" + ClientStatusInfo.JobsFetched);
+            Logger.Info("Increment FetchedJobs to:" + ClientStatusInfo.JobsFetched);
           }
         }
       } else
-        Logging.Instance.Info(this.ToString(), "No more jobs left!");
-      currentlyFetching = false;
+        Logger.Info("No more jobs left!");
+      CurrentlyFetching = false;
     }
 
@@ -350,11 +367,11 @@
     /// <param name="e"></param>
     void wcfService_StoreFinishedJobResultCompleted(object sender, StoreFinishedJobResultCompletedEventArgs e) {
-      Logging.Instance.Info(this.ToString(), "Job submitted with id " + e.Result.JobId);
+      Logger.Info("Job submitted with id " + e.Result.JobId);
       KillAppDomain(e.Result.JobId);
       if (e.Result.Success) {
         ClientStatusInfo.JobsProcessed++;
-        Debug.WriteLine("ProcessedJobs to:" + ClientStatusInfo.JobsProcessed);
+        Logger.Info("Increased ProcessedJobs to:" + ClientStatusInfo.JobsProcessed);
       } else {
-        Logging.Instance.Error(this.ToString(), "Sending of job " + e.Result.JobId + " failed, job has been wasted. Message: " + e.Result.StatusMessage);
+        Logger.Error("Sending of job " + e.Result.JobId + " failed, job has been wasted. Message: " + e.Result.StatusMessage);
       }
     }
@@ -366,5 +383,5 @@
     /// <param name="e"></param>
     void wcfService_ProcessSnapshotCompleted(object sender, ProcessSnapshotCompletedEventArgs e) {
-      Logging.Instance.Info(this.ToString(), "Snapshot " + e.Result.JobId + " has been transmitted according to plan.");
+      Logger.Info("Snapshot " + e.Result.JobId + " has been transmitted according to plan.");
     }
 
@@ -375,5 +392,5 @@
     /// <param name="e"></param>
     void wcfService_ServerChanged(object sender, EventArgs e) {
-      Logging.Instance.Info(this.ToString(), "ServerChanged has been called");
+      Logger.Info("ServerChanged has been called");
       lock (engines) {
         foreach (KeyValuePair<Guid, Executor> entries in engines) {
@@ -394,22 +411,33 @@
     /// <param name="e"></param>
     void wcfService_Connected(object sender, EventArgs e) {
+      Logger.Info("WCF Service got a connection");
       if (!UptimeManager.Instance.CalendarAvailable) {
-        ResponseCalendar calres = wcfService.GetCalendarSync(ConfigManager.Instance.GetClientInfo().Id);
-        if(calres.Success) {
-          if (UptimeManager.Instance.SetAppointments(false, calres))
-            wcfService.SetCalendarStatus(ConfigManager.Instance.GetClientInfo().Id, CalendarState.Fetched);
-          else
-            wcfService.SetCalendarStatus(ConfigManager.Instance.GetClientInfo().Id, CalendarState.NotAllowedToFetch);
-        }
-        else {
-          wcfService.SetCalendarStatus(ConfigManager.Instance.GetClientInfo().Id, CalendarState.NotAllowedToFetch);
-        }
+        Logger.Info("No local calendar available, fetch it");
+        FetchCalendarFromServer();
       }
       //if the fetching from the server failed - still set the client online... maybe we get 
-      //a result within the next few heartbeats
+      //a result within the next few heartbeats      
       if (!UptimeManager.Instance.CalendarAvailable || UptimeManager.Instance.IsOnline()) {
+        Logger.Info("CalendarAvailable is " + UptimeManager.Instance.CalendarAvailable + " and IsOnline is: " + UptimeManager.Instance.IsOnline());
+        Logger.Info("Setting client online");
         wcfService.LoginSync(ConfigManager.Instance.GetClientInfo());
         JobStorageManager.CheckAndSubmitJobsFromDisc();
-        currentlyFetching = false;
+        CurrentlyFetching = false;
+      }
+    }
+
+    private void FetchCalendarFromServer() {
+      ResponseCalendar calres = wcfService.GetCalendarSync(ConfigManager.Instance.GetClientInfo().Id);
+      if(calres.Success) {
+        if (UptimeManager.Instance.SetAppointments(false, calres)) {
+          Logger.Info("Remote calendar installed");
+          wcfService.SetCalendarStatus(ConfigManager.Instance.GetClientInfo().Id, CalendarState.Fetched);
+        } else {
+          Logger.Info("Remote calendar installation failed, setting state to " + CalendarState.NotAllowedToFetch);
+          wcfService.SetCalendarStatus(ConfigManager.Instance.GetClientInfo().Id, CalendarState.NotAllowedToFetch);
+        }
+      } else {
+        Logger.Info("Remote calendar installation failed, setting state to " + CalendarState.NotAllowedToFetch);
+        wcfService.SetCalendarStatus(ConfigManager.Instance.GetClientInfo().Id, CalendarState.NotAllowedToFetch);
       }
     }
@@ -417,9 +445,9 @@
     //this is a little bit tricky - 
     void wcfService_ConnectionRestored(object sender, EventArgs e) {
-      Logging.Instance.Info(this.ToString(), "Reconnected to old server - checking currently running appdomains");
+      Logger.Info("Reconnected to old server - checking currently running appdomains");
 
       foreach (KeyValuePair<Guid, Executor> execKVP in engines) {
         if (!execKVP.Value.Running && execKVP.Value.CurrentMessage == MessageContainer.MessageType.NoMessage) {
-          Logging.Instance.Info(this.ToString(), "Checking for JobId: " + execKVP.Value.JobId);
+          Logger.Info("Checking for JobId: " + execKVP.Value.JobId);
           Thread finThread = new Thread(new ParameterizedThreadStart(GetFinishedJob));
           finThread.Start(execKVP.Value.JobId);
@@ -435,5 +463,5 @@
 
     void appDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e) {
-      Logging.Instance.Error(this.ToString(), "Exception in AppDomain: " + e.ExceptionObject.ToString());
+      Logger.Error("Exception in AppDomain: " + e.ExceptionObject.ToString());    
     }
 
@@ -447,5 +475,5 @@
     /// <param name="id">the GUID of the job</param>
     private void KillAppDomain(Guid id) {
-      Logging.Instance.Info(this.ToString(), "Shutting down Appdomain for Job " + id);
+      Logger.Debug("Shutting down Appdomain for Job " + id);
       lock (engines) {
         try {
@@ -457,5 +485,5 @@
         }
         catch (Exception ex) {
-          Logging.Instance.Error(this.ToString(), "Exception when unloading the appdomain: ", ex);
+          Logger.Error("Exception when unloading the appdomain: ", ex);
         }
       }
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/CorePlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/CorePlugin.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/CorePlugin.cs	(revision 3578)
@@ -36,4 +36,5 @@
   [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
   [PluginDependency("HeuristicLab.Hive.JobBase-3.2")]
+  [PluginDependency("HeuristicLab.Tracing", "3.2.0")]
   public class CorePlugin: PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/Heartbeat.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/Heartbeat.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/Heartbeat.cs	(revision 3578)
@@ -32,4 +32,5 @@
 using HeuristicLab.Hive.Client.Core.ConfigurationManager;
 using HeuristicLab.Hive.Client.Communication.ServerService;
+using HeuristicLab.Tracing;
 //using BO = HeuristicLab.Hive.Contracts.BusinessObjects;
 
@@ -92,5 +93,5 @@
           //That's quiet simple: Just reconnect and you're good for new jobs
           if (wcfService.ConnState != NetworkEnum.WcfConnState.Loggedin) {
-            Logging.Instance.Info(this.ToString(), "Client goes online according to timetable");
+            Logger.Info("Client goes online according to timetable");
             wcfService.Connect();
           }
@@ -103,5 +104,5 @@
         wcfService.Connect();
       } else if (wcfService.ConnState == NetworkEnum.WcfConnState.Loggedin) {
-        Logging.Instance.Info(this.ToString(), "Sending Heartbeat: " + heartBeatData);        
+        Logger.Debug("Sending Heartbeat: " + heartBeatData);        
         wcfService.SendHeartBeatAsync(heartBeatData);
       }
@@ -109,5 +110,5 @@
 
     void wcfService_ProcessHeartBeatCompleted(object sender, ProcessHeartBeatCompletedEventArgs e) {
-      Logging.Instance.Info(this.ToString(), "Heartbeat received");
+      Logger.Debug("Heartbeat received");
       e.Result.ActionRequest.ForEach(mc => MessageQueue.GetInstance().AddMessage(mc));      
     }
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/HeuristicLab.Hive.Client.Core-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/HeuristicLab.Hive.Client.Core-3.2.csproj	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/HeuristicLab.Hive.Client.Core-3.2.csproj	(revision 3578)
@@ -157,4 +157,11 @@
       <Name>HeuristicLab.PluginInfrastructure</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Tracing\3.2\HeuristicLab.Tracing-3.2.csproj">
+      <Project>{EE2034D9-6E27-48A1-B855-42D45F69A4FC}</Project>
+      <Name>HeuristicLab.Tracing-3.2</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <WCFMetadata Include="Service References\" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/JobStorage/JobStorageManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/JobStorage/JobStorageManager.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/JobStorage/JobStorageManager.cs	(revision 3578)
@@ -11,4 +11,5 @@
 using System.Diagnostics;
 using System.Xml;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Client.Core.JobStorage {
@@ -28,8 +29,8 @@
         jobstream.Write(job, 0, job.Length);
         storedJobsList.Add(info);        
-        Logging.Instance.Info("JobStorageManager", "Job " + info.JobID + " stored on the harddisc");
+        Logger.Info("Job " + info.JobID + " stored on the harddisc");
       }
       catch (Exception e) {
-        Logging.Instance.Error("JobStorageManager", "Exception: ", e);
+        Logger.Error("Exception: ", e);
       }
       finally {
@@ -46,5 +47,5 @@
         if (WcfService.Instance.ConnState == NetworkEnum.WcfConnState.Loggedin && (storedJobsList[index-1].ServerIP == WcfService.Instance.ServerIP && storedJobsList[index-1].ServerPort == WcfService.Instance.ServerPort)) {
           String filename = storedJobsList[index-1].ServerIP + "." + storedJobsList[index-1].ServerPort + "." + storedJobsList[index-1].JobID.ToString();          
-          Logging.Instance.Info("JobStorageManager", "Sending stored job " + storedJobsList[index - 1].JobID + " to the server");
+          Logger.Info("Sending stored job " + storedJobsList[index - 1].JobID + " to the server");
           try {
             byte[] job = File.ReadAllBytes(path + filename + ".dat");
@@ -52,7 +53,7 @@
               ResponseResultReceived res = WcfService.Instance.SendStoredJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, storedJobsList[index - 1].JobID, job, 1.00, null, true);
               if (!res.Success)
-                Logging.Instance.Error("JobStorageManager", "sending of job failed: " + res.StatusMessage);
+                Logger.Error("sending of job failed: " + res.StatusMessage);
               else
-                Logging.Instance.Info("JobStorageManager", "Sending of job " + storedJobsList[index - 1].JobID + " done");
+                Logger.Info("Sending of job " + storedJobsList[index - 1].JobID + " done");
             }
             ClientStatusInfo.JobsProcessed++;
@@ -61,5 +62,5 @@
           }
           catch (Exception e) {
-            Logging.Instance.Error("JobStorageManager", "Job not on hdd but on list - deleting job from list", e);
+            Logger.Error("Job not on hdd but on list - deleting job from list ", e);
             storedJobsList.Remove(storedJobsList[index - 1]);
             StoreJobList();
@@ -78,5 +79,5 @@
 
     static JobStorageManager() {
-      Logging.Instance.Info("JobStorageManager", "Restoring Joblist from Harddisk");
+      Logger.Info("Restoring Joblist from Harddisk");
       if (!Directory.Exists(path))
         Directory.CreateDirectory(path);
@@ -89,8 +90,8 @@
           XmlTextReader reader = new XmlTextReader(stream);
           storedJobsList = (List<JobStorageInfo>)serializer.Deserialize(reader);
-          Logging.Instance.Info("JobStorageManager", "Loaded " + storedJobsList.Count + " Elements");
+          Logger.Info("Loaded " + storedJobsList.Count + " Elements");
         }
         catch (Exception e) {
-          Logging.Instance.Error("JobStorageManager", "Exception while loading the Stored Job List", e);
+          Logger.Error("Exception while loading the Stored Job List", e);
         } finally {
           if(stream != null) 
@@ -98,5 +99,5 @@
         }
       } else {
-        Logging.Instance.Info("JobStorageManager", "no stored jobs on harddisk, starting new list");
+        Logger.Info("no stored jobs on harddisk, starting new list");
         storedJobsList = new List<JobStorageInfo>();
       }
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/PluginCache.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/PluginCache.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/3.2/PluginCache.cs	(revision 3578)
@@ -7,4 +7,5 @@
 using HeuristicLab.Hive.Client.Common;
 using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Client.Core {
@@ -32,4 +33,5 @@
 
     public List<CachedHivePluginInfoDto> GetPlugins(List<HivePluginInfoDto> requests) {
+      Logger.Debug("Fetching plugins for job");
       List<CachedHivePluginInfoDto> neededPlugins = new List<CachedHivePluginInfoDto>();
       List<HivePluginInfoDto> missingPlugins = new List<HivePluginInfoDto>();
@@ -40,4 +42,5 @@
         foreach (CachedHivePluginInfoDto cache in pluginCache) {
           if (info.Name.Equals(cache.Name) && info.Version.Equals(cache.Version) && info.BuildDate <= cache.BuildDate) {
+            Logger.Debug("Found plugin " + info.Name + ", " + info.Version);
             neededPlugins.Add(cache);
             found = true;
@@ -46,14 +49,18 @@
         }
         if (!found)
+          Logger.Debug("Found NOT found " + info.Name + ", " + info.Version);
           missingPlugins.Add(info);
         found = false;
       }
 
+      Logger.Debug("Requesting missing plugins");
       List<CachedHivePluginInfoDto> receivedPlugins = WcfService.Instance.RequestPlugins(missingPlugins);
+      Logger.Debug("Requested missing plugins");
+
       if (receivedPlugins != null) {
         neededPlugins.AddRange(receivedPlugins);
         pluginCache.AddRange(receivedPlugins);
       } else
-        Logging.Instance.Error(this.ToString(), "Fetching of the plugins failed!");
+        Logger.Error("Fetching of the plugins failed!");
 
       return neededPlugins;
Index: /trunk/sources/HeuristicLab.Hive.Contracts/3.2/ApplicationConstants.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Contracts/3.2/ApplicationConstants.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Contracts/3.2/ApplicationConstants.cs	(revision 3578)
@@ -24,8 +24,13 @@
 using System.Linq;
 using System.Text;
+using System.Data;
 
 namespace HeuristicLab.Hive.Contracts {
   public class ApplicationConstants {
 
+    public static System.Data.IsolationLevel ISOLATION_LEVEL = IsolationLevel.ReadCommitted;
+
+    public static System.Transactions.IsolationLevel ISOLATION_LEVEL_SCOPE =
+      System.Transactions.IsolationLevel.ReadCommitted;
     public static int HEARTBEAT_MAX_DIF = 120; // value in seconds
     public static int JOB_TIME_TO_LIVE = 5;
Index: /trunk/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/JobDto.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/JobDto.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/JobDto.cs	(revision 3578)
@@ -48,4 +48,6 @@
     public DateTime? DateCalculated { get; set; }
     [DataMember]
+    public DateTime? DateFinished { get; set; }
+    [DataMember]
     public int Priority { get; set; }
     [DataMember]
Index: /trunk/sources/HeuristicLab.Hive.Contracts/3.2/HeuristicLab.Hive.Contracts-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Contracts/3.2/HeuristicLab.Hive.Contracts-3.2.csproj	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Contracts/3.2/HeuristicLab.Hive.Contracts-3.2.csproj	(revision 3578)
@@ -76,4 +76,5 @@
       <RequiredTargetFramework>3.0</RequiredTargetFramework>
     </Reference>
+    <Reference Include="System.Transactions" />
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
Index: /trunk/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IJobManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IJobManager.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IJobManager.cs	(revision 3578)
@@ -34,7 +34,11 @@
   public interface IJobManager {
     [OperationContract]
+    ResponseList<JobDto> GetAllJobsWithFilter(State jobState, int offset, int count);
+    [OperationContract]
     ResponseList<JobDto> GetAllJobs();
     [OperationContract]
     ResponseObject<JobDto> GetJobById(Guid jobId);
+    [OperationContract]
+    ResponseObject<JobDto> GetJobByIdWithDetails(Guid jobId);
     [OperationContract]
     ResponseObject<JobDto> AddNewJob(SerializedJob job);
@@ -62,5 +66,5 @@
     ResponseList<JobDto> GetJobsByProject(Guid projectId);
     [OperationContract]
-    ResponseObject<JobDto> AddJobWithGroupStrings(SerializedJob job, IEnumerable<string> resources);
+    ResponseObject<JobDto> AddJobWithGroupStrings(SerializedJob job, IEnumerable<string> resources);    
   }
 }
